require "ostruct"

module Partnerships
  class Educator < Class.new(OpenStruct)
  end
end

Course = Class.new(OpenStruct)
Locale = Class.new(OpenStruct)

module ActionController
  class Parameters < Class.new(Hash)
  end
end

CategoryDecorator = Class.new(OpenStruct)

module SchoolWebsite
  class CourseDecorator < Course
    def progress_text(_)
      super()
    end
  end

  ActivityDecorator = Class.new(OpenStruct)
  CourseCatalogDecorator = Class.new(OpenStruct)
  MyContentDecorator = Class.new(OpenStruct)
  UpcomingRegisteredEventsDecorator = Class.new(OpenStruct)
  TrainingSessionsDecorator = Class.new(OpenStruct)
  TrainingSessionDecorator = Class.new(OpenStruct)
end

class Learner < Class.new(OpenStruct)
  def access_course?(_)
    enrolled_in_course(_)
  end

  def enrolled_in_course?(_)
    super()
  end
end

class Person < Class.new(OpenStruct)
  def access_course?(_)
    enrolled_in_course(_)
  end

  def enrolled_in_course?(_)
    super()
  end
end

module Schools
  class Routes < Class.new(OpenStruct)
  end
end

module Search
  class CatalogResult < Class.new(OpenStruct)
  end
end

module LearnerSyllabuses
  ActivitiesCollection = Class.new(OpenStruct)
  Activity = Class.new(OpenStruct)
  Section = Class.new(OpenStruct)
  SectionsCollection = Class.new(OpenStruct)
  Syllabus = Class.new(OpenStruct)
end

module Draper
  class CollectionDecorator < Array
    alias :count :size
  end
end

module ActiveRecord
  module Associations
    class CollectionProxy < Array
    end
  end
end

class Array
  alias :count :size
end

class ColorScheme < Class.new(OpenStruct)
  def initialize(*args)
    super
    to_h.each do |method_name, _|
      define_singleton_method "#{method_name}?" do
        val = send(method_name)
        val != "" && !val.nil?
      end
    end
  end
end

require "schoolkeep/scribble"
Scribble::Registry.for Array do
  method :count
end

Schoolkeep::Scribble.stub = true
Schoolkeep::Scribble.register_models
