module Scribble
  module Methods
    class DisplaySearchCoursesForm < Method
      MY_CONTENT_CONTROLLER_IDENTIFIER = "school_website/my_content"
      SEARCH_CONTROLLER_IDENTIFIER = "school_website/search"

      register :display_search_form

      def display_search_form
        @receiver.variables[:current_school].search_enabled? && (my_content? || course_results?)
      end

      private

      def my_content?
        !!controller_context[MY_CONTENT_CONTROLLER_IDENTIFIER]
      end

      def course_results?
        !!controller_context[SEARCH_CONTROLLER_IDENTIFIER]
      end

      def controller_context
        @current_controller ||= @receiver.variables[:params].fetch(:controller, "")
      end
    end
  end
end
