require "i18n"
begin
  gem "activesupport", ">= 4.2.0"
rescue Gem::LoadError
  puts "activesupport is not installed, automatic pluralization will not work accurately"

  module FakePluralize
    def pluralize(locale)
      self + "s"
    end
  end

  unless defined?(ActiveSupport::Inflector)
    String.include(FakePluralize)
  end
end

module Scribble
  module Methods
    class Pluralize < Method
      register :pluralize, Fixnum, String, [String, 1]

      def pluralize(count, singular, plural = nil)
        if (count == 1 || count =~ /^1(\.0+)?$/)
          singular
        else
          plural || singular.pluralize(I18n.locale)
        end
      end
    end
  end
end
