module Scribble
  module Methods
    class Script < Method
      register :script, String

      def script(asset_name)
        "<script src='#{url(asset_name)}'></script>"
      end

      private

      def url(asset_name)
        template = custom_templates.find_by!(name: "#{asset_name}.js")

        school.routes.url_helpers.custom_asset_url(
          school.uuid,
         "#{asset_name}-#{template.fingerprint}.js",
         options
        )
      end

      def school
        @receiver.variables[:current_school]
      end

      def custom_templates
        @receiver.variables[:custom_templates]
      end

      def asset_host
        @receiver.variables[:asset_host]
      end

      def asset_host_port
        @receiver.variables[:asset_host_port]
      end

      def options
        { port: asset_host_port, protocol: false }.tap do |h|
          h[:host] = asset_host if asset_host
        end
      end
    end
  end
end
