require "net/http"
require "uri"

module Schoolkeep
  module Views
    class AssetCache
      attr_reader :host

      def initialize(host)
        @host = host
      end

      def [](path)
        cached_get(path) || path
      end

      private

      def get(path)
        url = File.join(host, path)
        res = Net::HTTP.get_response(URI(url))
        res["location"]
      end

      def cached_get(path)
        cache[path] ||= get(path)
      end

      def cache
        @cache ||= {}
      end
    end
  end
end
